package esercizio3;
import java.util.*;

public class CalcolaCodiceFiscale {
	
	public static enum Genere{M,F};
	
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		
		System.out.println("Programma per il calcolo della prima parte del codice fiscale.");
		System.out.print("Inserire il cognome: ");
		String cognome = tastiera.nextLine().replaceAll(" ","");
		System.out.print("Inserire il nome: ");
		String nome = tastiera.nextLine().replaceAll(" ","");
		System.out.print("Inserire la data di nascita (gg/mm/aaaa): ");
		String dataNascita = tastiera.next();
		System.out.print("Inserire il genere (M/F): ");
		String genere = tastiera.next();
		
		String codiceFiscale = "";
		codiceFiscale += estrai(cognome.toUpperCase());
		codiceFiscale += estrai(nome.toUpperCase());
		codiceFiscale += codiceData(dataNascita,Genere.valueOf(genere));
		
		System.out.println("La porzione di codice fiscale generato e': "+codiceFiscale);
		
		tastiera.close();
	}
	
	public static String estrai(String stringa){
		String daRestituire = "";
		int i=0, j=0;
		while(i<3 && j<stringa.length()){
			switch(stringa.charAt(j)){
			case 'A':
			case 'E':
			case 'I':
			case 'O':
			case 'U':
				break;
			default:
				daRestituire += stringa.charAt(j);
				i++;
			}
			j++;
		}
		j=0;
		while(i<3 && j<stringa.length()){
			switch(stringa.charAt(j)){
			case 'A':
			case 'E':
			case 'I':
			case 'O':
			case 'U':
				daRestituire += stringa.charAt(j);
				i++;
				break;
			default:
			}
			j++;
		}
		return daRestituire;
	}
	
	public static String codiceData(String data, Genere genere){
		String daRestituire="";
		daRestituire += data.substring(data.length()-2);
		switch(Integer.parseInt(data.substring(data.indexOf('/')+1,data.lastIndexOf('/')))){
		case 1:
			daRestituire += 'A';
			break;
		case 2:
			daRestituire += 'B';
			break;
		case 3:
			daRestituire += 'C';
			break;
		case 4:
			daRestituire += 'D';
			break;
		case 5:
			daRestituire += 'E';
			break;
		case 6:
			daRestituire += 'H';
			break;
		case 7:
			daRestituire += 'L';
			break;
		case 8:
			daRestituire += 'M';
			break;
		case 9:
			daRestituire += 'P';
			break;
		case 10:
			daRestituire += 'R';
			break;
		case 11:
			daRestituire += 'S';
			break;
		case 12:
			daRestituire += 'T';
			break;
		}
		int giorno = Integer.parseInt(data.substring(0,data.indexOf('/')));
		if(genere == Genere.F)
			giorno += 40;
		if(giorno < 10)
			daRestituire += '0';
		daRestituire += giorno;
		return daRestituire;
	}

}
